# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ethercat_trigger_controllers/MultiWaveform.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ethercat_trigger_controllers.msg

class MultiWaveform(genpy.Message):
  _md5sum = "6a8e166563c159e73f391a302e7b37f6"
  _type = "ethercat_trigger_controllers/MultiWaveform"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Transitions will occur at k * period + zero_offset + transitions[j].time, where j and
# k are integers.

float64 period # Period of the waveform in seconds.
float64 zero_offset # Time corresponding to a time of 0 in times[] in seconds
MultiWaveformTransition[] transitions # Transitions in the waveform. Transition times should be in increasing order, and be between 0 (inclusive) and period (exclusive)

================================================================================
MSG: ethercat_trigger_controllers/MultiWaveformTransition
# Used to specify a transition in the SetMultiWaveform service.

float64 time # Transition time after start of period.
uint32 value # Value of the digital output after the transition time.
string topic # Topic to publish the transition timestamp to, or empty string if the transition should not be published.
"""
  __slots__ = ['period','zero_offset','transitions']
  _slot_types = ['float64','float64','ethercat_trigger_controllers/MultiWaveformTransition[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       period,zero_offset,transitions

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MultiWaveform, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.period is None:
        self.period = 0.
      if self.zero_offset is None:
        self.zero_offset = 0.
      if self.transitions is None:
        self.transitions = []
    else:
      self.period = 0.
      self.zero_offset = 0.
      self.transitions = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2d().pack(_x.period, _x.zero_offset))
      length = len(self.transitions)
      buff.write(_struct_I.pack(length))
      for val1 in self.transitions:
        _x = val1
        buff.write(_get_struct_dI().pack(_x.time, _x.value))
        _x = val1.topic
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.transitions is None:
        self.transitions = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.period, _x.zero_offset,) = _get_struct_2d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.transitions = []
      for i in range(0, length):
        val1 = ethercat_trigger_controllers.msg.MultiWaveformTransition()
        _x = val1
        start = end
        end += 12
        (_x.time, _x.value,) = _get_struct_dI().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.topic = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.topic = str[start:end]
        self.transitions.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2d().pack(_x.period, _x.zero_offset))
      length = len(self.transitions)
      buff.write(_struct_I.pack(length))
      for val1 in self.transitions:
        _x = val1
        buff.write(_get_struct_dI().pack(_x.time, _x.value))
        _x = val1.topic
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.transitions is None:
        self.transitions = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.period, _x.zero_offset,) = _get_struct_2d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.transitions = []
      for i in range(0, length):
        val1 = ethercat_trigger_controllers.msg.MultiWaveformTransition()
        _x = val1
        start = end
        end += 12
        (_x.time, _x.value,) = _get_struct_dI().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.topic = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.topic = str[start:end]
        self.transitions.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_dI = None
def _get_struct_dI():
    global _struct_dI
    if _struct_dI is None:
        _struct_dI = struct.Struct("<dI")
    return _struct_dI
